package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.DatosCosultoresCompletosFacturacion;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

@Stateless
public class DatosCosultoresCompletosFacturacionFacade extends AbstractFacade<DatosCosultoresCompletosFacturacion> implements DatosCosultoresCompletosFacturacionFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public DatosCosultoresCompletosFacturacionFacade() {
        super(DatosCosultoresCompletosFacturacion.class);
    }

    @Override
    public DatosCosultoresCompletosFacturacion find(String id) {


        return find(id);
    }

    @Override
    public DatosCosultoresCompletosFacturacion busquedaDato(String consultorCodigo) {
        DatosCosultoresCompletosFacturacion rs = new DatosCosultoresCompletosFacturacion();
        StringBuilder sql = new StringBuilder("call obtener_consultor_facturacion(?)");
        Query q = em.createNativeQuery(sql.toString(), DatosCosultoresCompletosFacturacion.class);
        q.setParameter(1, consultorCodigo);
        List<DatosCosultoresCompletosFacturacion> dts = q.getResultList();
        rs = (dts.isEmpty()) ? new DatosCosultoresCompletosFacturacion() : dts.get(0);

        return rs;
    }

    @Override
    public void ActualizaConsultorMasivo(String codigoConsutor) {
        StringBuilder sql = new StringBuilder("Update consultores_datos set consultor_masivo = 1 where consultor_codigo = ?");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, codigoConsutor);
        q.executeUpdate();

    }

}
